## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# ReusableArenaAllocator Class Template Reference

`#include <ReusableArenaAllocator.hpp>`

Inheritance diagram for ReusableArenaAllocator:

[legend]
Collaboration diagram for ReusableArenaAllocator:

[legend]
List of all members.

## Public Types

- typedef ReusableArenaBlock<
  ObjectType> ReusableArenaBlockType
- typedef ReusableArenaBlockType::size_type size_type
- typedef ArenaAllocator<ObjectType,
  ReusableArenaBlockType> BaseClassType
- typedef ReusableArenaAllocator<
  ObjectType> ThisType
- typedef XalanList<ReusableArenaBlockType*> ArenaBlockListType
- typedef ArenaBlockListType::iterator iterator
- typedef ArenaBlockListType::const_iterator const_iterator
- typedef ArenaBlockListType::reverse_iterator reverse_iterator
- typedef ArenaBlockListType::const_reverse_iterator const_reverse_iterator

## Public Methods

- ReusableArenaAllocator (MemoryManagerType &theManager, size_type theBlockSize, bool destroyBlocks=false)
- virtual ~ReusableArenaAllocator ()
- bool destroyObject (ObjectType *theObject)
- virtual ObjectType* allocateBlock ()
- virtual void commitAllocation (ObjectType *theObject)
- virtual bool ownsObject (const ObjectType *theObject) const

## Protected Methods

- void destroyBlock ()

## Protected Attributes

- const bool m_destroyBlocks

### template<class ObjectType> class ReusableArenaAllocator

## Member Typedef Documentation

template<class ObjectType>
typedef XalanList< ReusableArenaBlockType *> ReusableArenaAllocator<ObjectType>::ArenaBlockListType<ReusableArenaBlockType*>

| Reimplemented from ArenaAllocator.

template<class ObjectType>
typedef ArenaAllocator< ObjectType, ReusableArenaBlockType > ReusableArenaAllocator<ObjectType>::BaseClassType<ObjectType, ReusableArenaBlockType>

template<class ObjectType>
typedef ReusableArenaBlock< ObjectType > ReusableArenaAllocator<ObjectType>::ReusableArenaBlockType<ObjectType>

template<class ObjectType>
typedef ReusableArenaAllocator< ObjectType > ReusableArenaAllocator<ObjectType>::ThisType<ObjectType>

| Reimplemented from ArenaAllocator.

template<class ObjectType>
typedef ArenaBlockListType::const_iterator ReusableArenaAllocator<ObjectType>::const_iterator

template<class ObjectType>
typedef ArenaBlockListType::const_reverse_iterator ReusableArenaAllocator<ObjectType>::const_reverse_iterator

template<class ObjectType>
typedef ArenaBlockListType::iterator ReusableArenaAllocator<ObjectType>::iterator

template<class ObjectType>
typedef ArenaBlockListType::reverse_iterator ReusableArenaAllocator<ObjectType>::reverse_iterator

template<class ObjectType>
typedef ReusableArenaBlockType::size_type ReusableArenaAllocator<ObjectType>::size_type

| Reimplemented from ArenaAllocator.

## Constructor & Destructor Documentation

template<class ObjectType>
ReusableArenaAllocator<ObjectType>::ReusableArenaAllocator<ObjectType> ( | MemoryManagerType & theManager,
| size_type theBlockSize,
| bool destroyBlocks = false )

template<class ObjectType>
ReusableArenaAllocator<ObjectType>::~ReusableArenaAllocator<ObjectType> ( | )`[virtual]`

## Member Function Documentation

template<class ObjectType>
ObjectType * ReusableArenaAllocator<ObjectType>::allocateBlock ( | )`[virtual]`

| Reimplemented from ArenaAllocator.

template<class ObjectType>
void ReusableArenaAllocator<ObjectType>::commitAllocation ( | ObjectType * theObject )`[virtual]`

| Reimplemented from ArenaAllocator.

template<class ObjectType>
void ReusableArenaAllocator<ObjectType>::destroyBlock ( | )`[protected]`

template<class ObjectType>
bool ReusableArenaAllocator<ObjectType>::destroyObject ( | ObjectType * theObject )

template<class ObjectType>
bool ReusableArenaAllocator<ObjectType>::ownsObject ( | const ObjectType * theObject ) const`[virtual]`

| Reimplemented from ArenaAllocator.

## Member Data Documentation

template<class ObjectType>
const bool ReusableArenaAllocator<ObjectType>::m_destroyBlocks`[protected]`

The documentation for this class was generated from the following file:

- ReusableArenaAllocator.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.